;; support
(define (F m1 m2 r)
  (/ (* G m1 m2)
     r r))

(define G
  (layers 6.67408e-11
          (support-layer (support-set 'CODATA-2018))))

(define M-Earth
  (layers 5.9722e24
          (support-layer (support-set 'Astronomical-Almanac-2016))))

(define M-Moon
  (layers 7.342e22
          (support-layer (support-set 'NASA-2006))))

(define a-Moon
  (layers 384399e3
          (support-layer (support-set 'Wieczorek-2006))))

(F M-Earth M-Moon a-Moon)
;; #[layers 1.9805035857209e20
;;          (support (support-set nasa-2006
;;                                codata-2018
;;                                astronomical-almanac-2016
;;                                wieczorek-2006))]

;; units
(define (F m1 m2 r)
  (/ (* G m1 m2)
     r r))

(define G
  (layers 6.67408e-11
          (unit-layer (unit 'meter 3 'kilogram -1 'second -2))))

(define M-Earth
  (layers 5.9722e24
          (unit-layer (unit 'kilogram 1))))

(define M-Moon
  (layers 7.342e22
          (unit-layer (unit 'kilogram 1))))

(define a-Moon
  (layers 384399e3
          (unit-layer (unit 'meter 1))))

(F M-Earth M-Moon a-Moon)
;; #[layers 1.9805035857209e20
;;          (unit (unit kilogram 1 meter 1 second -2))]

;; full
(define (F m1 m2 r)
  (/ (* G m1 m2)
     r r))

(define G
  (layers 6.67408e-11
          (support-layer (support-set 'CODATA-2018))
          (unit-layer (unit 'meter 3 'kilogram -1 'second -2))))

(define M-Earth
  (layers 5.9722e24
          (support-layer (support-set 'Astronomical-Almanac-2016))
          (unit-layer (unit 'kilogram 1))))

(define M-Moon
  (layers 7.342e22
          (support-layer (support-set 'NASA-2006))
          (unit-layer (unit 'kilogram 1))))

(define a-Moon
  (layers 384399e3
          (support-layer (support-set 'Wieczorek-2006))
          (unit-layer (unit 'meter 1))))

(F M-Earth M-Moon a-Moon)
;; #[layers 1.9805035857209e20
;;          (support (support-set nasa-2006
;;                                codata-2018
;;                                astronomical-almanac-2016
;;                                wieczorek-2006))
;;          (unit (unit kilogram 1 meter 1 second -2))]

;; now make F layered
(define F
  (layers F
          (support-layer
           (lambda (supports bases)
             (apply support-set-union
                    (support-set 'newton)
                    (get-layer-value G support-layer) ; maybe merge?
                    supports)))))

(F M-Earth M-Moon a-Moon)
;; note: for some reason, prints with ellipses...
;; #[layers 1.9805035857209e20
;;          (unit (unit kilogram 1 meter 1 second -2))
;;          (support (support-set wieczorek-2006
;;                                nasa-2006
;;                                astronomical-almanac-2016
;;                                codata-2018
;;                                newton))]
