(layer 1 2 3)
;; (layer 1 2 3)

(layers 1 ((layer 1 2 3) 9) ((layer 3 4 5) 10))
;; #[layers 1 (1 9) (3 10)]

(merge-layer-bindings
 '((1 2) (3 4) (5 6))
 '((7 8) (3 8) (1 10)))
;; ((7 8) (1 2) (3 4) (5 6))

(bindings-have-layer?
 '((1 2) (3 4) (5 6))
 '1)
;; (1 2)

(define layer1
  (layer 1 2 3))
(define layer4
  (layer 4 5 6))
(define layer7
  (layer 7 8 9))

(layers (layers 1 (layer1 3) (layer4 5))
        (layer1 6)
        (layer7 9))
;Value: #[layers 1 (4 5) (1 6) (7 9)]

(get-layer-value 'a base-layer)
;; a

(get-layer-value 'a support-layer)
;; (support-set)

(get-layer-value (layers 'a (support-layer (support-set 'b)))
                 base-layer)
;; a

(get-layer-value (layers 'a (support-layer (support-set 'b)))
                 support-layer)
;; (support-set b)

(get-layer-value (layers 'a (support-layer (support-set 'b)))
                 unit-layer)
;; (unit)

(if (layers #t)
    1
    2)
;; 1

(if (layers #f)
    1
    2)
;; 2

(cond ((layers #t) 1)
      ((layers #f) 2))
;; 1

(cond ((layers #f) 1)
      ((layers #t) 2))
;; 2

