;;; support helpers
(define (support:*2 supports bases)
  (let ((v1 (car bases))
        (v2 (cadr bases))
        (s1 (car supports))
        (s2 (cadr supports)))
    (if (exact-zero? v1)
        (if (exact-zero? v2)
            (if (< (length (support-set-elements s1))
                   (length (support-set-elements s2)))
                s1
                s2)   ;arbitrary
            s1)
        (if (exact-zero? v2)
            s2
            (support-set-union s1 s2)))))

(define (support:default-procedure supports bases)
  (apply support-set-union supports))

(define (exact-zero? x)
  (and (n:number? x) (exact? x) (n:zero? x)))

;;; support layer
(define support-layer
  (layer 'support
         (list base-layer)
         (simple-compute-default-value (support-set))))
(install-handler! support-layer '*2 support:*2)
(install-handler! support-layer '1/ support:default-procedure)
(install-handler! support-layer '+ support:default-procedure)
(install-handler! support-layer '- support:default-procedure)
